package ca.mcgill.sel.aspectoptima.aspects.transaction;

import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoverableDeferring;
import ca.mcgill.sel.aspectoptima.aspects.twophaselocking.TwoPhaseLocked;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.transaction.ConcurrencyControl;

public interface TransactableDeferringTwoPhaseLocking  extends Transactable, RecoverableDeferring, TwoPhaseLocked {
	// public method signatures from structural view
	// empty
}

aspect TransactableDeferringTwoPhaseLockingAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @TransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING) * implements TransactableDeferringTwoPhaseLocking;

	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}
