package ca.mcgill.sel.aspectoptima.aspects.transaction;

import ca.mcgill.sel.aspectoptima.aspects.nested.NestedParticipant;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;

public interface TransactionParticipantCheckpointingTwoPhaseLockingNested extends TransactionParticipantCheckpointingTwoPhaseLocking, NestedParticipant {
	// public method signatures from structural view
	// empty
}

aspect TransactionParticipantCheckpointingTwoPhaseLockingNestedAspect {
	// bind annotations to mandatory instantiation parameters	
	declare parents : @TransactionParticipantClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * implements TransactionParticipantCheckpointingTwoPhaseLockingNested;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}
