package ca.mcgill.sel.aspectoptima.aspects.transaction;

import ca.mcgill.sel.aspectoptima.aspects.optimisticvalidation.OptimisticallyValidatingParticipant;
import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoveringParticipantDeferring;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;

public interface TransactionParticipantDeferringOptimisticValidation extends TransactionParticipant, RecoveringParticipantDeferring, OptimisticallyValidatingParticipant {
	// public method signatures from structural view
	// empty
}

aspect TransactionParticipantDeferringOptimisticValidationAspect {
	// bind annotations to mandatory instantiation parameters	
	declare parents : @TransactionParticipantClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) * implements TransactionParticipantDeferringOptimisticValidation;

	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}