package ca.mcgill.sel.aspectoptima.conflictresolutions;

import ca.mcgill.sel.aspectoptima.aspects.nested.NestedContext;
import ca.mcgill.sel.aspectoptima.aspects.twophaselocking.TwoPhaseLockingParticipant;
import ca.mcgill.sel.aspectoptima.aspects.nested.NestedParticipant;

privileged aspect TwoPhaseLockingAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	void around(NestedParticipant target, NestedContext c) : execution(void TwoPhaseLockingParticipant.releaseAcquiredLocks(..)) && target(target) && args(c) {
		NestedContext parent = c.getParent();
		if (parent == null) {
			proceed(target, c);
		}
	}
}