package ca.mcgill.sel.aspectoptima.test;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.tracing.*;

@TracedClass
public class TracingTest {
	public static void main(String[] args) {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.beginTracing();
		TracingTest test = new TracingTest();
		test.foo(1);
		test.bar(4,5);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.end();
	}
	
	@TracedMethod(AccessKind.READ)
	void foo(int a) {
		bar(2,3);
	}
	
	@TracedMethod(AccessKind.READ)
	void bar(int a, int b) {
		
	}
}