package ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevotable;

import ca.mcgill.sel.aspectoptimaomtt.aspects.terminatable.TerminatableParticipant;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.*;

public interface OutcomeVotableParticipant extends OutcomeControllingParticipant, TerminatableParticipant {
	// public method signatures from structural view
	// empty
}

aspect OutcomeVotableParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @OutcomeVotableParticipantClass * implements OutcomeVotableParticipant;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	void around(OutcomeVotableParticipant target, Outcome v) : execution(void OutcomeControllingParticipant.voteAndLeaveContext(..)) && target(target) && args(v) {
		OutcomeVotableContext context = (OutcomeVotableContext) target.getContext();
		context.registerVote(v, target);
		target.leaveContext();
	}
}