package ca.mcgill.sel.aspectoptimaomtt.interfacing;
//package ca.mcgill.sel.aspectoptima;
//
//import org.aspectj.lang.annotation.AdviceName;
//import ca.mcgill.sel.aspectoptima.annotation.omtt.*;
//import ca.mcgill.sel.aspectoptima.annotation.omtt.interfacing.*;
//import ca.mcgill.sel.aspectoptima.annotation.*;
//import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTParticipant;
//import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTransactableMethod;
//
//public aspect OMTTInterfacing {
//	declare precedence : OMTTInterfacing, *;
//
//	/** add annotations for class automatically based on the annotation of their methods */
//	declare @type : hasmethod(@OMTTransactableMethod(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING) * *.*(..)) : @OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING);
//	
//	declare @type : hasmethod(@OMTTransactableMethod(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING) * *.*(..)) : @OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING);
//	
//	declare @type : hasmethod(@OMTTransactableMethod(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION) * *.*(..)) : @OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);
//	
//	declare @type : hasmethod(@OMTTransactableMethod(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION) * *.*(..)) : @OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);
//	
//	declare @type : hasmethod(@SharedMethod * *.*(..)) : @SharedClass;	
//	
//	/** add annotations for auto transacted class */
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING);
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING);
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING);
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING);
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);
//	declare @type : (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) *) : @OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);
//	
//	/** add annotations for methods of auto transacted class */
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
//	declare @method : (* (@AutoOMTTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) *).*(..)) : @OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
//	
//	pointcut abortOnThrowingMethodExecution(AbortOMTTransactionOnThrowing abortAnnotation, OMTTransactableMethod transactedMethodAnnotation) : execution(* *.*(..)) && @annotation(abortAnnotation) && @annotation(transactedMethodAnnotation);
//	
//	/**
//	 * aborts the current transaction if a method annotated with 
//	 * @AbortTransactionOnThrowing(ThrowableToCatch.class) throws a Throwable
//	 */
//	@AdviceName("abortTransactionOnThrowing")
//	after(AbortOMTTransactionOnThrowing abortAnnotation, OMTTransactableMethod transactedMethodAnnotation) throwing(Throwable t): abortOnThrowingMethodExecution(abortAnnotation, transactedMethodAnnotation) {
//		Class<?> abortClass = abortAnnotation.value();
//		// check whether: t instanceof abortClass
//		if (abortClass.isInstance(t)) {
//			OMTTParticipant participant = AspectOPTIMAOMTT.getOMTTParticipant(transactedMethodAnnotation);
//			participant.abortTransaction();
//		}
//	}
//}
