package ca.mcgill.sel.aspectoptima.aspects.accessclassified;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as AccessClassified for the AspectOPTIMA Framework. <br>
 */
@Target({ElementType.TYPE}) 
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface AccessClassifiedClass {
	// empty
}