package ca.mcgill.sel.aspectoptima.aspects.checkpointable;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as Checkpointable for the AspectOPTIMA Framework. <br>
 * The needed annotation @CopyableClass is added automatically. <br>
 */
@Target({ElementType.TYPE}) 
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface CheckpointableClass {
	// empty
}