package ca.mcgill.sel.aspectoptima.aspects.context;

public interface Context {
	// public method signatures from structural view
	void contextCompleted();
}

aspect ContextAspect {
	// attributes & associations from structural view
	private Participant Context.participant = null;
	
	// declared methods without message views
	void Context.addParticipant(Participant participant) {
		// BEGIN implementation refinement
		/* FIXME throw exception if this.participant != null || completed */
		this.participant = participant;
		// END implementation refinement
	}
	
	void Context.removeParticipant(Participant participant) {
		// BEGIN implementation refinement
		/* FIXME throw exception if this.participant == null || completed */
		this.participant = null;
		// END implementation refinement
	}
	
	public void Context.contextCompleted() {
		// FIXME implement introduced method-stub
	}

	// methods shown in message views
	// empty
}
