package ca.mcgill.sel.aspectoptima.aspects.transaction;

import ca.mcgill.sel.aspectoptima.aspects.optimisticvalidation.OptimisticallyValidated;
import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoverableCheckpointing;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.transaction.ConcurrencyControl;

public interface TransactableCheckpointingOptimisticValidation extends Transactable, RecoverableCheckpointing, OptimisticallyValidated {
	// public method signatures from structural view
	// empty
}

aspect TransactableCheckpointingOptimisticValidationAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @TransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION) * implements TransactableCheckpointingOptimisticValidation;

	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}
