package ca.mcgill.sel.aspectoptima.aspects.transaction;

import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoverableCheckpointing;
import ca.mcgill.sel.aspectoptima.aspects.twophaselocking.TwoPhaseLocked;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.transaction.ConcurrencyControl;

public interface TransactableCheckpointingTwoPhaseLocking extends Transactable, RecoverableCheckpointing, TwoPhaseLocked {
	// public method signatures from structural view
	// empty
}

aspect TransactableCheckpointingTwoPhaseLockingAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @TransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING) * implements TransactableCheckpointingTwoPhaseLocking;

	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}
