package ca.mcgill.sel.aspectoptima.aspects.transaction;

import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoveringParticipantDeferring;
import ca.mcgill.sel.aspectoptima.aspects.twophaselocking.TwoPhaseLockingParticipant;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;

public interface TransactionParticipantDeferringTwoPhaseLocking extends TransactionParticipant, RecoveringParticipantDeferring, TwoPhaseLockingParticipant {
	// public method signatures from structural view
	// empty
}

aspect TransactionParticipantDeferringTwoPhaseLockingAspect {
	// bind annotations to mandatory instantiation parameters	
	declare parents : @TransactionParticipantClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) * implements TransactionParticipantDeferringTwoPhaseLocking;

	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}
