package ca.mcgill.sel.aspectoptimaomtt;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.*;
import ca.mcgill.sel.aspectoptima.aspects.checkpointable.*;
import ca.mcgill.sel.aspectoptima.aspects.checkpointing.*;
import ca.mcgill.sel.aspectoptima.aspects.context.*;
import ca.mcgill.sel.aspectoptima.aspects.copyable.*;
import ca.mcgill.sel.aspectoptima.aspects.deferrable.*;
import ca.mcgill.sel.aspectoptima.aspects.deferring.*;
import ca.mcgill.sel.aspectoptima.aspects.lockable.*;
import ca.mcgill.sel.aspectoptima.aspects.nested.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.blockable.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.closable.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.entrysynchronizing.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.exitsynchronizing.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevotable.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevoting.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.pausable.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.shared.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.spawnsupporting.*;
import ca.mcgill.sel.aspectoptimaomtt.aspects.terminatable.*;
import ca.mcgill.sel.aspectoptima.aspects.optimisticvalidation.*;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.*;
import ca.mcgill.sel.aspectoptima.aspects.recovering.*;
import ca.mcgill.sel.aspectoptima.aspects.traceable.*;
import ca.mcgill.sel.aspectoptima.aspects.tracing.*;
import ca.mcgill.sel.aspectoptima.aspects.transaction.*;
import ca.mcgill.sel.aspectoptima.aspects.twophaselocking.*;

public aspect AnnotationInheritanceAspect {
	// OpenMultithreadedTransaction instantiates Transaction
	/* TODO !!! FIX ANNOTATION INHERITANCE PROBLEM! */
	/* declare @type : (@OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING) *) : @TransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING); */
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION, nested = true);
	
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
	declare @method : (@OMTTransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * *.*(..)) : @TransactableMethod(accessKind = AccessKind.UPDATE, updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true);
	
	declare @type : (@OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING) *) : @TransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING);
	declare @type : (@OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION) *) : @TransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);
	declare @type : (@OMTTransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION) *) : @TransactableClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION);

	// Shared instantiates AccessClassified
	declare @type : @SharedClass * : @AccessClassifiedClass;
	declare @method : (@SharedMethod(AccessKind.READ) * *.*(..)) : @AccessClassifiedMethod(AccessKind.READ);
	declare @method : (@SharedMethod(AccessKind.WRITE) * *.*(..)) : @AccessClassifiedMethod(AccessKind.WRITE);
	declare @method : (@SharedMethod(AccessKind.UPDATE) * *.*(..)) : @AccessClassifiedMethod(AccessKind.UPDATE);
	
	// Shared instantiates Lockable
	declare @type : @SharedClass * : @LockableClass;
}
