package ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction;

import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactionParticipantCheckpointingTwoPhaseLockingNested;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.transaction.ConcurrencyControl;

public interface OMTTParticipantCheckpointingTwoPhaseLockingNested extends OMTTParticipantCheckpointingTwoPhaseLocking, TransactionParticipantCheckpointingTwoPhaseLockingNested {
	// public method signatures from structural view
	// empty
}

aspect OMTTParticipantCheckpointingTwoPhaseLockingNestedAspect {
	// bind annotations to mandatory instantiation parameter interfaces	
	declare parents : @OMTTParticipantClass(updateStrategy = UpdateStrategy.CHECKPOINTING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true) * implements OMTTParticipantCheckpointingTwoPhaseLockingNested;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}