package ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction;

import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactableDeferringOptimisticValidation;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.transaction.ConcurrencyControl;

public interface OMTTransactableDeferringOptimisticValidation  extends OMTTransactable, TransactableDeferringOptimisticValidation {
	// public method signatures from structural view
	// empty
}

aspect OMTTransactableDeferringOptimisticValidationAspect {
	// bind annotations to mandatory instantiation parameter interfaces	
	declare parents : @OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.OPTIMISTICVALIDATION) * implements OMTTransactableDeferringOptimisticValidation;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
}