package ca.mcgill.sel.aspectoptimaomtt.conflictresolutions.exitsynchronizingspawnsupporting;

import ca.mcgill.sel.aspectoptimaomtt.aspects.exitsynchronizing.ExitSynchronizingParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.exitsynchronizing.ExitSynchronizingContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.spawnsupporting.SpawnSupportingContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.spawnsupporting.SpawnSupportingParticipant;

privileged aspect ExitSynchronizingParticipantAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	void around(SpawnSupportingParticipant target) : execution(void ExitSynchronizingParticipant.waitOrReleaseBeforeLeaving()) && target(target) {
		boolean spawned = target.isSpawned();
		if (!spawned) {
			proceed(target);
		}
	}
}